<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <meta name="generator" content="pandoc" />
  <title></title>
  <style type="text/css">code{white-space: pre;}</style>
</head>
<body>
<style>
body {
    margin: auto;
    padding-right: 1em;
    padding-left: 1em;
    max-width: 44em;
    border-left: 1px solid black;
    border-right: 1px solid black;
    color: black;
    font-family: Verdana, sans-serif;
    font-size: 100%;
    line-height: 140%;
    color: #333;
}
pre, tt{
    font-family: monospace;
    background-color:#f8f8f8;
    padding: 2px 4px;
}
code{
    background-color:#f8f8f8;
    white-space: pre-wrap;
    font-size: 110%;
    padding: 1px 1px;
}
h1 a, h2 a, h3 a, h4 a, h5 a, li a {
    text-decoration: none;
    color: #7a5ada;
}
h1, h2, h3, h4, h5 { font-family: verdana;
                     font-weight: bold;
                     /*border-bottom: 1px dotted black;*/
                     color: #7a5ada; }
h1 {
        font-size: 130%;
}

h2 {
        font-size: 110%;
                     border-bottom: 1px dotted black;
}

h3 {
        font-size: 100%;
                     border-bottom: 1px dotted black;
}

h4 {
        font-size: 90%;
        font-style: italic;
                     border-bottom: 1px dotted black;
}

h5 {
        font-size: 85%;
        font-style: italic;
                     border-bottom: 1px dotted black;
}

h1.title {
        font-size: 200%;
        font-weight: bold;
        padding-top: 0.2em;
        padding-bottom: 0.2em;
        text-align: left;
        border: none;
}

dt code {
        font-weight: bold;
}
dd p {
        margin-top: 0;
}

#footer {
        padding-top: 1em;
        font-size: 70%;
        color: gray;
        text-align: center;
}
</style>
<div id="TOC">
<ul>
<li><a href="#reports">Reports</a><ul>
<li><a href="#groupby">groupby</a></li>
<li><a href="#options">options</a><ul>
<li><a href="#b-begin_date">-b BEGIN_DATE</a></li>
<li><a href="#c-context">-c CONTEXT</a></li>
<li><a href="#d-depth">-d DEPTH</a></li>
<li><a href="#e-end_date">-e END_DATE</a></li>
<li><a href="#f-file">-f FILE</a></li>
<li><a href="#h-hue">-h HUE</a></li>
<li><a href="#k-keyword">-k KEYWORD</a></li>
<li><a href="#l-location">-l LOCATION</a></li>
<li><a href="#o-omit">-o OMIT</a></li>
<li><a href="#s-summary">-s SUMMARY</a></li>
<li><a href="#t-tags">-t TAGS</a></li>
<li><a href="#u-user">-u USER</a></li>
<li><a href="#w-width1">-w WIDTH1</a></li>
<li><a href="#w-width2">-W WIDTH2</a></li>
</ul></li>
</ul></li>
</ul>
</div>
<h1 id="reports"><a href="#reports">Reports</a></h1>
<p><em>etm</em> supports creating, printing and exporting reports. Either click on the report icon in the main window or press <em>Control-R</em> to open the report dialog.</p>
<pre><code>Usage:  &lt;report type character&gt; &lt;groupby setting&gt; [report options]</code></pre>
<p>A <em>report specification</em> is created by entering a report <em>type character</em> followed by a <em>groupby setting</em> and, perhaps, by one or more <em>report options</em>. Together, the type character, groupby setting and options determine which items will appear in the report and how they will be organized and displayed.</p>
<p>There are two possible report type characters, <em>a</em> and <em>c</em>:</p>
<ul>
<li><p><strong>a</strong>: action or accounting report. A report of expenditures of time and money recorded in actions with output formatted using <code>action_template</code> computations and expansions.</p></li>
<li><p><strong>c</strong>: custom report. Any item types but without <code>action_template</code> computations and expansions.</p></li>
</ul>
<p>Available <code>action_template</code> expansions for <em>action</em> reports include:</p>
<ul>
<li><p><code>!label!</code> the item or group label.</p></li>
<li><p><code>!count!</code> the number of children represented in the reported item or group.</p></li>
<li><p><code>!minutes!</code> the total time from <code>@e</code> entries in minutes rounded up using the setting for <code>action_minutes</code>.</p></li>
<li><p><code>!hours!</code> if action_minutes = 1, the time in hours and minutes. Otherwise, the time in floating point hours.</p></li>
<li><p><code>!value!</code> the billing value of the rounded total time. Requires an action entry such as <code>@v br1</code> and a setting for <code>action_rates</code>.</p></li>
<li><p><code>!expense!</code> the total expense from <code>@x</code> entries.</p></li>
<li><p><code>!charge!</code> the billing value of the total expense. Requires an action entry such as <code>@w mu1</code> and a setting for <code>action_markups</code>.</p></li>
<li><p><code>!total!</code> the sum of <code>!value!</code> and <code>!charge!</code>.</p></li>
</ul>
<p>Note: when aggregating amounts in action reports, billing and markup rates are applied first to times and expenses for individual actions and the resulting amounts are then aggregated. Similarly, when times are rounded up, the rounding is done for individual actions and the results are then aggregated.</p>
<p>See <em>help/preferences</em> for further details about setting <code>action_template</code>.</p>
<p>You can select a report specification from a list of saved specifications, modify an existing specification or create an entirely new specification. Clicking on the <em>create report</em> icon or pressing <em>Control-R</em> will create a report based on the current specification.</p>
<p>When you edit an existing specification, the background color of the entry field will change to yellow to indicate that this is a new, as yet unsaved specification. Pressing <em>Return</em> will add the new specification temporarily to the list without affecting the original specification.</p>
<p>If the current specification has been modified, then deleting it by clicking on the <em>delete</em> icon or pressing <em>Control-D</em> will replace the modified specification with the original. If the current specification has not been modified, then deleting it will temporarily remove it from the list.</p>
<p>When temporary changes have been made to the list, the <em>save</em> button will be enabled and you can either click on this button or press <em>Control-S</em> to save the changes. If you attempt to close the reports dialog while there are unsaved changes, you will be given the opportunity to save them.</p>
<h3 id="groupby"><a href="#groupby">groupby</a></h3>
<p>A semicolon separated list that determines how items will be grouped and sorted. Possible elements include <em>date specifications</em> and elements from</p>
<dl>
<dt>c</dt>
<dd><p>context</p>
</dd>
<dt>f</dt>
<dd><p>file path</p>
</dd>
<dt>k</dt>
<dd><p>keyword</p>
</dd>
<dt>t</dt>
<dd><p>tag</p>
</dd>
<dt>u</dt>
<dd><p>user</p>
</dd>
</dl>
<p>A <em>date specification</em> is either:</p>
<dl>
<dt>w</dt>
<dd>week number
</dd>
</dl>
<p>or a combination of one or more of the following:</p>
<dl>
<dt>yy</dt>
<dd><p>2-digit year</p>
</dd>
<dt>yyyy</dt>
<dd><p>4-digit year</p>
</dd>
<dt>M</dt>
<dd><p>month: 1 - 12</p>
</dd>
<dt>MM</dt>
<dd><p>month: 01 - 12</p>
</dd>
<dt>MMM</dt>
<dd><p>locale specific abbreviated month name: Jan - Dec</p>
</dd>
<dt>MMMM</dt>
<dd><p>locale specific month name: January - December</p>
</dd>
<dt>d</dt>
<dd><p>month day: 1 - 31</p>
</dd>
<dt>dd</dt>
<dd><p>month day: 01 - 31</p>
</dd>
<dt>ddd</dt>
<dd><p>locale specific abbreviated week day: Mon - Sun</p>
</dd>
<dt>dddd</dt>
<dd><p>locale specific week day: Monday - Sunday</p>
</dd>
</dl>
<p>For example, <code>c ddd, MMM d yyyy</code> would group by year, month and day together to give output such as</p>
<pre><code>Fri, Apr 1 2011
    items for April 1
Sat, Apr 2 2011
    items for April 2
...</code></pre>
<p>On the other hand, <code>a w; u; k[0]; k[1:]</code> would group by week number, user and keywords to give output such as</p>
<pre><code>13.1) Week 14: Mar 31 - Apr 6, 2014
   6.3) agent 1
      1.3) client 1
         1.3) project 2
            1.3) Activity (12)
      5) client 2
         4.5) project 1
            4.5) Activity (21)
         0.5) project 2
            0.5) Activity (22)
   6.8) agent 2
      2.2) client 1
         2.2) project 2
            2.2) Activity (13)
      4.6) client 2
         3.9) project 1
            3.9) Activity (23)
         0.7) project 2
            0.7) Activity (23)</code></pre>
<p>As another example, <code>c t -t tag 1, !tag 3</code> would group by tag showing items that have a tag matching <code>tag 1</code> but not one matching <code>tag 3</code>.</p>
<p>With the heirarchial elements, file path and keyword, it is possible to use parts of the element as well as the whole. Consider, for example, the file path <code>A/B/C</code> with the components <code>[A, B, C]</code>. Then for this file path:</p>
<pre><code>f[0] = A
f[:2] = A/B
f[2:] = C
f = A/B/C</code></pre>
<p>Suppose that keywords have the format <code>client:project</code>. Then <code>c MMM yyyy; k[0]; k[1]</code> would group by year and month, then client and finally project to give output such as</p>
<pre><code>Apr 2011
    client a
        project 1
            items for client a project 1 for April
        project 2
            items for client a project 2 for April
    client b
        project i
            items for client b project i for April
...</code></pre>
<p>Items that are missing an element specified in <code>groupby</code> will be omitted from the output. E.g., undated tasks and notes will be omitted when a date specification is included, items without keywords will be omitted when <code>k</code> is included and so forth.</p>
<p>When a date specification is not included in <code>groupby</code>, undated notes and tasks will be potentially included, but only those instances of dated items that correspond to the <em>relevant datetime</em> of the item of the item will be included, where the <em>relevant datetime</em> is the past due date for any past due tasks, the starting datetime for any non-repeating item and the datetime of the next instance for any repeating item.</p>
<p>Within groups, items are automatically sorted by date, type and time.</p>
<h3 id="options"><a href="#options">options</a></h3>
<p>Report options are listed below. Report types <code>c</code> supports all options except <code>-d</code>. Report type <code>a</code> supports all options except <code>-o</code> and <code>-h</code>.</p>
<h4 id="b-begin_date"><a href="#b-begin_date">-b BEGIN_DATE</a></h4>
<p>Fuzzy parsed date. Limit the display of dated items to those with datetimes falling <em>on or after</em> this datetime. Relative day and month expressions can also be used so that, for example, <code>-b -14</code> would begin 14 days before the current date and <code>-b -1/1</code> would begin on the first day of the previous month. It is also possible to add (or subtract) a time period from the fuzzy date, e.g., <code>-b mon + 7d</code> would begin with the second Monday falling on or after today. Default: None.</p>
<h4 id="c-context"><a href="#c-context">-c CONTEXT</a></h4>
<p>Regular expression. Limit the display to items with contexts matching CONTEXT (ignoring case). Prepend an exclamation mark, i.e., use !CONTEXT rather than CONTEXT, to limit the display to items which do NOT have contexts matching CONTEXT.</p>
<h4 id="d-depth"><a href="#d-depth">-d DEPTH</a></h4>
<p>The default, <code>-d 0</code>, includes all outline levels. Use <code>-d 1</code> to include only level 1, <code>-d 2</code> to include levels 1 and 2 and so forth. For example, a report that appears as follows with the default, <code>-d 0</code>:</p>
<center>
<img src="images/action_report0.png" title="v entered in pattern filter" />
</center>

<p>Exporting this report (CSV format) would give:</p>
<center>
<img src="images/action_export0.png" title="vo entered in pattern filter" />
</center>


<p>With <code>-d 3</code>, these would change to</p>
<center>
<img src="images/action_report3.png" title="v entered in pattern filter" /> <img src="images/action_export3.png" title="vo entered in pattern filter" />
</center>

<p>and, with <code>-d 2</code> to</p>
<center>
<img src="images/action_report2.png" title="v entered in pattern filter" /> <img src="images/action_export2.png" title="vo entered in pattern filter" />
</center>

<p>In this example, the relevant settings from <code>etm.cfg</code> are</p>
<pre><code>action_minutes: 6
action_rates:
    default: 100.0
    br1:    125.0
    br2:    150.0
action_template: &#39;!hours!h $!value! !label! (!count!)&#39;</code></pre>
<p>The <em>default</em> <code>action_rate</code> is used for client 1, <em>br1</em> for client 2 and <em>br3</em> for client 3.</p>
<h4 id="e-end_date"><a href="#e-end_date">-e END_DATE</a></h4>
<p>Fuzzy parsed date. Limit the display of dated items to those with datetimes falling <em>before</em> this datetime. As with BEGIN_DATE relative month expressions can be used so that, for example, <code>-b -1/1  -e 1</code> would include all items from the previous month. As with <code>-b</code>, period strings can be appended, e.g., <code>-b mon -e mon + 7d</code> would include items from the week that begins with the first Monday falling on or after today. Default: None.</p>
<h4 id="f-file"><a href="#f-file">-f FILE</a></h4>
<p>Regular expression. Limit the display to items from files whose paths match FILE (ignoring case). Prepend an exclamation mark, i.e., use !FILE rather than FILE, to limit the display to items from files whose path does NOT match FILE.</p>
<h4 id="h-hue"><a href="#h-hue">-h HUE</a></h4>
<p>0, 1 or 2. <code>-h 2</code> uses all possible colors for leaf fonts, <code>-h 1</code> uses red for past due items and black for everything else and <code>-h 0</code> uses black for everything. The default is taken from the setting for <code>colors</code> in <code>emt.cfg</code>.</p>
<h4 id="k-keyword"><a href="#k-keyword">-k KEYWORD</a></h4>
<p>Regular expression. Limit the display to items with contexts matching KEYWORD (ignoring case). Prepend an exclamation mark, i.e., use !KEYWORD rather than KEYWORD, to limit the display to items which do NOT have keywords matching KEYWORD.</p>
<h4 id="l-location"><a href="#l-location">-l LOCATION</a></h4>
<p>Regular expression. Limit the display to items with location matching LOCATION (ignoring case). Prepend an exclamation mark, i.e., use !LOCATION rather than LOCATION, to limit the display to items which do NOT have a location that matches LOCATION.</p>
<h4 id="o-omit"><a href="#o-omit">-o OMIT</a></h4>
<p>String. Show/hide a)ctions, d)elegated tasks, e)vents, g)roup tasks, n)otes, o)ccasions and/or other t)asks. For example, <code>-o on</code> would show everything except occasions and notes and <code>-o !on</code> would show only occasions and notes.</p>
<h4 id="s-summary"><a href="#s-summary">-s SUMMARY</a></h4>
<p>Regular expression. Limit the display to items containing SUMMARY (ignoring case) in the item summary. Prepend an exclamation mark, i.e., use !SUMMARY rather than SUMMARY, to limit the display to items which do NOT contain SUMMARY in the summary.</p>
<h4 id="t-tags"><a href="#t-tags">-t TAGS</a></h4>
<p>Comma separated list of case insensitive regular expressions. E.g., use</p>
<pre><code>-t tag1, !tag2</code></pre>
<p>to display items with one or more tags that match 'tag1' but none that match 'tag2'.</p>
<h4 id="u-user"><a href="#u-user">-u USER</a></h4>
<p>Regular expression. Limit the display to items with user matching USER (ignoring case). Prepend an exclamation mark, i.e., use !USER rather than USER, to limit the display to items which do NOT have a user that matches USER.</p>
<h4 id="w-width1"><a href="#w-width1">-w WIDTH1</a></h4>
<p>Integer. Limit the first column display width to this number of characters. Default: <code>report_width1</code> in etm.cfg.</p>
<h4 id="w-width2"><a href="#w-width2">-W WIDTH2</a></h4>
<p>Integer. Limit the second column display width to this number of characters. Default: <code>report_width2</code> in etm.cfg.</p>
</body>
</html>
